/********************************************************************************
 *																				*
 *	   " "										*						*
 *																				* 
 ********************************************************************************/

int CALLBACK AboutDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
    switch (message) 
    { 
        case WM_COMMAND: 
            if (wParam==IDOK||IDCANCEL) 
				{ 
				EndDialog(hDlg, wParam); 
				return TRUE; 
				} 
    } 
    return FALSE; 
} 



/********************************************************************************
 *																				*
 *	    										*															*
 *																				* 
 ********************************************************************************/

int CALLBACK LevelDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{

int Button;
 
 switch (message) 
    { 
     case WM_INITDIALOG:
        switch (Level)
			{
			case 0: Button=IDC_EASYLVL; break;
			case 1: Button=IDC_NORMALLVL; break;
			case 2: Button=IDC_HARDLVL; break;
			}
        SendDlgItemMessage(hDlg, Button, BM_SETCHECK, (WPARAM)true, (LPARAM)0);
       	break;

     case WM_COMMAND: 
        if (wParam == IDOK) 
           { 
            EndDialog(hDlg, TRUE); 
            return TRUE; 
           } 
		if (wParam == IDCANCEL) 
           { 
			Level=OldLevel;
            EndDialog(hDlg, TRUE); 
            return TRUE; 
           } 
        if (HIWORD(wParam) == BN_CLICKED) 
           { 
            switch (LOWORD(wParam)) 
                  { 
                   case IDC_EASYLVL: 
                            Level=0; 
                            break; 
 
                   case IDC_NORMALLVL: 
                            Level=1; 
                            break; 
 
                   case IDC_HARDLVL: 
                            Level=2; 
                            break; 
                  } 
           } 
       } 
	return FALSE; 
}



/********************************************************************************
 *																				*
 *	   ""											*					*
 *																				* 
 ********************************************************************************/

int CALLBACK OptionsDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 

WPARAM CheckState;
 
 switch (message) 
    { 
     case WM_INITDIALOG:
        if (Walls) CheckState=BST_CHECKED; else CheckState=BST_UNCHECKED;
		SendDlgItemMessage(hDlg, IDC_WALLS, BM_SETCHECK, (WPARAM)CheckState, (LPARAM)0);
       	break;

     case WM_COMMAND: 
        if (wParam == IDOK) 
				{ 
				EndDialog(hDlg, TRUE); 
				return TRUE; 
				} 
		if (wParam == IDCANCEL) 
				{ 
				Walls=OldWalls;
				EndDialog(hDlg, TRUE); 
				return TRUE; 
				} 
        if (HIWORD(wParam) == BN_CLICKED) 
				{ 
				switch (LOWORD(wParam)) 
                  { 
                   case IDC_WALLS: 
                            Walls=!Walls; 
                            break; 
                  } 
           } 
       } 
    return FALSE; 
}



