#include <stdio.h>
#include <time.h>
#include <windows.h>
#include "resource.h"
#include "predefined.h"

#include <dinput.h>

#pragma comment (lib, "dxguid.lib")
#pragma comment (lib, "dinput8.lib")




struct AppleCell                 //   " "
{
 short int x,y;
};

struct SnakeCell                 //   "  "
{
 short int x,y,neck;
};

struct MapFile			         //   ""
{
 SnakeCell Body[4];					//  
 short int Map[BWIDTH*BHEIGHT];		//  
};

int NmOfStones;

MapFile		CurMapFile;


HWND		hWnd;			//     
HINSTANCE	hInstance;		//  

HDC			hDC;			//    
HDC			hAppleDC;   	//   ,  
HDC			hTopDC;
HDC			hStoneDC;
HDC			hBodyDC[14];	//   ,   
HFONT		hFont;

bool        Active;         //    
bool        Walls;          //  
bool        OldWalls;       //    
int         Level;          //  
int         OldLevel;       //   
int         Score;
int			TickCount;
int			Time[3]={150,105,75};
int			Delay;

bool Init(void);			// 
void CALLBACK TimerProc( HWND hWnd, UINT uMsg, UINT idEvent, DWORD dwTime);
void UpdateWnd(void);		//  
void ClearTrash(void);	    //   



//   

int         Dir;            // 
int         OldDir;         //  
int         Length; 
int         NextHead;        
int         NextNeck;
int         NextTail;

SnakeCell	Body[BWIDTH*BHEIGHT];  //  
SnakeCell   Head;                  // 

void InitSnake();              // 
void MoveHead(void);           //  
void ShowSnake(void);          //  
void EraseSnake(void);         //  
bool Crashed(void);            //  
bool Horizontal(void);         //    
int GetNextHead(void);
int GetNextNeck(void);
int GetNextTail(void);

#include "snake.h"


//   

AppleCell Apple;  

void ShowApple(void);
void NewApple(void);
bool AppleAte(void);  

#include "apple.h"


//  

int CALLBACK AboutDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam); 
int CALLBACK LevelDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
int CALLBACK OptionsDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

#include "dialogs.h"


//   

bool SaveData(void);
bool ReadData(void);
bool ReadFile(char Name[256]);

#include "files.h"


//   

bool LoadBitmapToDC(HDC &HTempDC, WORD DescInt);  

#include "graphtools.h"


//  
/*
void TestGettingCoords(void);
void TestGettingNm(void);

#include "test.h"
*/

char     buffer[256];

#include "DITools.h"
