/********************************************************************************
 *																				*
 *	 															*
 *																				* 
 ********************************************************************************/

void InitSnake(void)
{
	Dir=RIGHT;      //  
	OldDir=RIGHT;   // 
		
	Length=4;       //  
	
	//     
	Body[0].x=3;	Body[0].y=0;	
	Body[1].x=2;	Body[1].y=0;	Body[1].neck=4;
	Body[2].x=1;	Body[2].y=0;	Body[2].neck=4;
	Body[3].x=0;	Body[3].y=0;	Body[3].neck=13;

	NextNeck=4;
			
	//  Head  Body[0]       
	Head.x=3;		Head.y=0;

	Score=0;
	TickCount=0;
	
}



/********************************************************************************
 *																				*
 *	     .								*
 *																				* 
 ********************************************************************************/

void MoveHead(void)
{
 switch (Dir)
{
	case UP:    if (!Walls&&Head.y==0) Head.y=BHEIGHT-1; else Head.y--; break;
	case DOWN:  if (!Walls&&Head.y==BHEIGHT-1) Head.y=0; else Head.y++; break;
    case LEFT:  if (!Walls&&Head.x==0) Head.x=BWIDTH-1; else  Head.x--; break;
    case RIGHT: if (!Walls&&Head.x==BWIDTH-1) Head.x=0; else  Head.x++; break;
}

 OldDir=Dir;
  
}



/********************************************************************************
 *																				*
 *	    .											*
 *	  State -  : NORMAL  CRASHED.				*
 *																				* 
 ********************************************************************************/

void ShowSnake(bool State)
{

switch (State)
	{
	case true:
	case false:;
	}

// 
if (!Crashed()) NextHead=GetNextHead(); //   ,    
BitBlt(hDC,Body[0].x*BLOCKSZ+XOFFS,Body[0].y*BLOCKSZ+YOFFS,
	   BLOCKSZ, BLOCKSZ,hBodyDC[NextHead],0,0,SRCCOPY);

// 2-  
if (!Crashed()) Body[1].neck=NextNeck; //   ,    
BitBlt(hDC,Body[1].x*BLOCKSZ+XOFFS,Body[1].y*BLOCKSZ+YOFFS,
	   BLOCKSZ, BLOCKSZ,hBodyDC[Body[1].neck],0,0,SRCCOPY);

// 
for (int cnt=2;cnt<Length;cnt++)
		{
	    BitBlt(hDC,Body[cnt].x*BLOCKSZ+XOFFS,Body[cnt].y*BLOCKSZ+YOFFS,
	    BLOCKSZ, BLOCKSZ,hBodyDC[Body[cnt].neck],0,0,SRCCOPY);
		}

// 
if (!Crashed()) NextTail=GetNextTail(); //   ,    
BitBlt(hDC,Body[Length-1].x*BLOCKSZ+XOFFS,Body[Length-1].y*BLOCKSZ+YOFFS,
	   BLOCKSZ, BLOCKSZ,hBodyDC[NextTail],0,0,SRCCOPY);

}



/********************************************************************************
 *																				*
 *	C  .													*
 *																				* 
 ********************************************************************************/

void EraseSnake(void)
//
{   
	SelectObject(hDC, GetStockObject(BLACK_BRUSH)); 
	
	for (int cnt=0;cnt<Length;cnt++)
		 Rectangle(hDC,Body[cnt].x*BLOCKSZ+XOFFS,Body[cnt].y*BLOCKSZ+YOFFS,
		 (Body[cnt].x*BLOCKSZ)+BLOCKSZ+XOFFS,(Body[cnt].y*BLOCKSZ)+BLOCKSZ+YOFFS);
		
}



/********************************************************************************
 *																				*
 *	 ,        .				*
 *	 true,  .													*
 *																				* 
 ********************************************************************************/

bool Crashed(void)
//

{ 
if (Walls&&(Head.x<0||Head.y<0||Head.x==BWIDTH||Head.y==BHEIGHT)) return true;
if (CurMapFile.Map[(Head.x + Head.y*BWIDTH)]==1) return true;
for (int cnt=3; cnt<=Length-1; cnt++)
	{
	if (Head.x==Body[cnt].x && Head.y==Body[cnt].y) 
		{
		EraseSnake();
		Length=cnt;
		NextTail=GetNextTail();
		ShowSnake(NORMAL);
		}
	//return true;
	}
return false;  
}



/********************************************************************************
 *																				*
 *	    .								*
 *	 true,     .							*
 *																				* 
 ********************************************************************************/

bool Horizontal(void)
{
	if (Body[0].y==Body[1].y) return true;
    return false;
}



/********************************************************************************
 *																				*
 *	    .								*
 *	:     .							*
 *																				* 
 ********************************************************************************/

int GetNextHead(void)
{
return Dir;
}



/********************************************************************************
 *																				*
 *	    .								*
 *	:     2-  .					*
 *																				* 
 ********************************************************************************/

int GetNextNeck(void)
{
if ((Dir==UP&&OldDir==UP)||(Dir==DOWN&&OldDir==DOWN)) return 5;
else if ((Dir==LEFT&&OldDir==LEFT)||(Dir==RIGHT&&OldDir==RIGHT)) return 4;

else if ((Dir==RIGHT&&OldDir==UP)||(Dir==DOWN&&OldDir==LEFT)) return 6;
else if ((Dir==UP&&OldDir==LEFT)||(Dir==RIGHT&&OldDir==DOWN)) return 8;
else if ((Dir==DOWN&&OldDir==RIGHT)||(Dir==LEFT&&OldDir==UP)) return 7;
else if ((Dir==UP&&OldDir==RIGHT)||(Dir==LEFT&&OldDir==DOWN)) return 9;

return 0;

}



/********************************************************************************
 *																				*
 *	    .								*
 *	:     .							*
 *																				* 
 ********************************************************************************/

int GetNextTail(void)
{
if (Body[Length-1].x>Body[Length-2].x) return 13;
else if (Body[Length-1].x<Body[Length-2].x) return 12;
else if (Body[Length-1].y>Body[Length-2].y) return 10;
else if (Body[Length-1].y<Body[Length-2].y) return 11;

return 0;

}		